package scalapi.quickfixj

import quickfix.Log
import java.lang.String
import scalapi.lang.TransformationChannel
import scalapi.lang.Implicits._

class TransformationChannelLog(transformationChannel: TransformationChannel) extends Log {

  transformationChannel.assertNotNull()

  def clear() {
    throw new RuntimeException("Operation not supported.")
  }

  def onIncoming(message: String) {
    transformationChannel.transform(new InMessage(message))
  }

  def onOutgoing(message: String) {
    transformationChannel.transform(new OutMessage(message))
  }

  def onEvent(message: String) {
    transformationChannel.transform(new EventMessage(message))
  }

  def onErrorEvent(message: String) {
    transformationChannel.transform(new ErrorMessage(message))
  }

}

case class InMessage(message: String)

case class OutMessage(message: String)

case class EventMessage(message: String)

case class ErrorMessage(message: String)
