package scalapi.quickfixj

import quickfix.{Log, SessionID, LogFactory}
import scalapi.lang.TransformationChannel


class TransformationChannelLogFactory(defaultLogHandler: PartialFunction[Any, Any]) extends LogFactory {

  val transformationChannel = new TransformationChannel(defaultLogHandler)

  def addPreTransformation(transformation: PartialFunction[Any, Object]) {
    transformationChannel.addPreTransformation(transformation)
  }

  def create(): Log =
    new TransformationChannelLog(transformationChannel)

  def create(sessionID: SessionID): Log =
    new TransformationChannelLog(transformationChannel)

}